#--------------------------------------------------------------------------------
sub summarize
#--------------------------------------------------------------------------------
{
  # Transaction integrity - Issue BEGIN WORK ( by turning off autocommit)
  #$dbh->{AutoCommit} = 0;
  
  &logit("summarize() - Summarizing readings for WWW"); 

  my $zver;
  my @misc1;
  my @misc2;
  my @misc3;
  my @misc4;
  my @misc5;
  my @misc6;
  my @misc7;
  my @misc8;
  my @misc9;
  my @misc10;

  $flag_test_mode = 0; 
  $flag_user_list = 0; 
  $flag_helper = 0; 
  $flag_uptime = 0; 
  $flag_readings = 1; 

  ##$color_event_background = "lightslategray"; 
  $color_event_background = "dcdcdc"; 

  &sumprint("","","S");

  $rptfile = "$rptdir/instances.txt";
  open(RPT,  ">$rptfile"  ) || &error_msg("Can't open output $rptfile - $!");
  $rptfile = "$rptdir/instances_sn.txt";
  open(RPTSN,">$rptfile"  ) || &error_msg("Can't open output $rptfile - $!");
  open(HTMLSYS,">$html_sys_path"  ) || &error_msg("Can't open output $html_sys_path - $!");

  print RPT "System                             Hardware   OS-Ver    Inf-Ver     Inf-S/N    DBs DBSpcs Tables Aloc Used Maxusers\n";
  print RPTSN "# Informix Instances and Serial Numbers\n";

  print HTMLSYS "<title>DBAmon Instance Summary</title>\n";
  print HTMLSYS "<meta http-equiv='Refresh' content='3600'>\n";
  print HTMLSYS "<body bgcolor=white>\n";
  print HTMLSYS "<table><tr><td><img src='img/dbamonlogo.jpg'>\n";
  print HTMLSYS "<tr bgcolor=wheat><td><font size=5 face=Verdana><center>Instance Summary</center></font>\n";
  print HTMLSYS "</table>\n";
  print HTMLSYS "<ul><font size=-1>\n";
  print HTMLSYS "<li> <a HREF='$dbamon_home'><b>DBAmon Home Page</a> </b>\n";
  print HTMLSYS "<li> <a HREF='index.html'><b>DBAmon WWW Index</a> </b>\n";
  print HTMLSYS "</ul></font>\n";

  chop($date = `date`);
  print HTMLSYS "<font size=-2><i>This page was generated by DBAmon version <b>$verrel</b>(Perl) running on system: $wsname on $date - Started $strdate</i></font>\n";

  #---- Create scoreboard
  $g_ok      = 0;
  $g_inhibit = 0;
  $g_perf    = 0;
  $g_warn    = 0;
  $g_perf    = 0;
  $g_sec     = 0;
  $g_user    = 0;
  $g_info    = 0;
  $g_warning = 0;
  $g_download= 0;
  $g_critical= 0;
  $g_nomon   = 0;
  $g_bkonly  = 0;
  $g_notation = 0;

  $i_rm = 1;
  while ($i_rm <= $high_host) 
  {
    #---- Create instance_details rows for this instance
    &instanceDetails($i_rm); 

    # Clear work variables 
    $zhost = "";
    $zdomain = "";

    ##print "warning="m_warning[$i_rm] " $i_rm="$i_rm " high_host="high_host
    if (($m_info[$i_rm] + $m_warning[$i_rm] + $m_critical[$i_rm]) == 0) 
    {
      $g_ok += 1;
    }

    ##print "m_info[$i_rm]=$m_info[$i_rm]\n";

    if ($m_note[$i_rm]     > 0) { $g_notation += $m_note[$i_rm]; }
    if ($m_sec[$i_rm]      > 0) { $g_sec      += $m_sec[$i_rm]; }
    if ($m_perf[$i_rm]     > 0) { $g_perf     += $m_perf[$i_rm]; }
    if ($m_user[$i_rm]     > 0) { $g_user     += $m_user[$i_rm]; }
    if ($m_info[$i_rm]     > 0) { $g_info     += $m_info[$i_rm]; }
    if ($m_warning[$i_rm]  > 0) { $g_warning  += $m_warning[$i_rm]; }
    if ($m_critical[$i_rm] > 0) { $g_critical += $m_critical[$i_rm]; }

    if ($runmon[$i_rm] eq "N") 
    {
      $g_nomon += 1
    }

    if ($runmon[$i_rm] eq "B") 
    {
      $g_bkonly += 1
    }

    if ($up[$i_rm] eq "I") 
    {
      $g_inhibit  += 1;
    }
    $i_rm++;
  }

  if (($high_host - $g_inhibit) == 0)
  {
    $health = 0;
  }
  else
  {
    $health = sprintf ("%.1f", $g_ok / ($high_host - $g_inhibit) * 100 );
  }

  if    ($health >= 70) { $health_c = "lime" }
  elsif ($health >= 50) { $health_c = "yellow" }
  else                  { $health_c = "red" }

  #---- Scoreboard

  $time_end = time();

  $etime = int(($time_end - $time_start) / 60);
  $time_total = $time_end - $time_start;

  print HTMLSYS "<hr><h4>Scoreboard - Iteration: #$iter_count - Duration: $etime Minute(s)</h4>\n";
  print HTMLSYS "<table border=1 bgcolor=lightgrey>\n";
  print HTMLSYS "<tr bgcolor=$table_headbgcolor><th><h5><i>Instance<br>Status<th><h5><i>Instance<br>Count<th><h5><i>Health Index<br>(0-100)\n";

  &logit("Updating DB with instance data");
  ##&logit("DEBUG g_info=$g_info");

  &sumtot("T", "Inhibited -or- Must_Be_Up=N Down",  $g_inhibit,  "black"  );
  &sumtot("T", "No Events",                         $g_ok,       "lime"  );
  &sumtot("T", "Info Events",                       $g_info,     "slateblue" );
  &sumtot("T", "Performance Events",                $g_perf,     "lightskyblue" );
  &sumtot("T", "Security Events",                   $g_sec,      "mediumpurple" );
  &sumtot("T", "Notation Events",                   $g_notation, "lime" );
  &sumtot("T", "User Events",                       $g_user,     "#99cc00" );
  &sumtot("T", "Warning Events",                    $g_warning,  "yellow" );
  &sumtot("T", "Critical Events",                   $g_critical, "red" );
  &sumtot("T", "Software Download Failed",          $g_download, "gray" );
  &sumtot("T", "Monitoring Turned Off",             $g_nomon,    "white" );
  &sumtot("T", "Backup Monitoring Only(B)",         $g_bkonly,   "lime" );

  &logit("Creating WWW Instance Summary html data");

  print HTMLSYS "<tr>  <td bgcolor=black    ><h5><font color=silver>Instance Inhibited -or- Must_Be_Up=N Instance Down\n";
  print HTMLSYS " <td align=right> <h5> $g_inhibit \n";
  print HTMLSYS " <td rowspan=8 bgcolor=$health_c> <center> <h1>$health</center>\n";
  print HTMLSYS "<tr> <td bgcolor=lime      ><h5>No Events\n";
  print HTMLSYS " <td align=right> <h5>$g_ok\n";
  print HTMLSYS "<tr> <td bgcolor=slateblue    ><h5>Info Events\n";
  print HTMLSYS " <td align=right> <h5>$g_info \n";
  print HTMLSYS "<tr> <td bgcolor=yellow    ><h5>Warning Events\n";
  print HTMLSYS " <td align=right> <h5>$g_warning \n";
  print HTMLSYS "<tr> <td bgcolor=red       ><h5>Critical Events\n";
  print HTMLSYS " <td align=right> <h5>$g_critical \n";
  print HTMLSYS "<tr> <td bgcolor=gray      ><h5>Software Download Failed\n";
  print HTMLSYS " <td align=right> <h5>$g_download \n";
  print HTMLSYS "<tr> <td bgcolor=white     ><h5>Monitoring Turned Off\n";
  print HTMLSYS " <td align=right> <h5>$g_nomon \n";
  print HTMLSYS "<tr> <td bgcolor=lime      ><h5>Backup Monitoring Only(B)\n";
  print HTMLSYS " <td align=right> <h5>$g_bkonly \n";

  $num_all = $num_oracle + $num_informix + $num_mssql + $num_oracleapps + $num_oraclent + $num_sap;

  if ($num_oracle     eq "") { $num_oracle     = 0 }
  if ($num_oracleapps eq "") { $num_oracleapps = 0 }
  if ($num_oraclent   eq "") { $num_oraclent   = 0 }
  if ($num_informix   eq "") { $num_informix   = 0 }
  if ($num_mssql      eq "") { $num_mssql      = 0 }
  if ($num_sap        eq "") { $num_sap        = 0 }

  if ($num_all == 0) 
  {
    $num_all = 1;   # Prevent divide by 0
  }

  $pct_oracleapps = int(($num_oracleapps / $num_all) * 100);
  $pct_oraclent   = int(($num_oraclent   / $num_all) * 100);
  $pct_oracle     = int(($num_oracle     / $num_all) * 100);
  $pct_informix   = int(($num_informix   / $num_all) * 100);
  $pct_mssql      = int(($num_mssql      / $num_all) * 100);
  $pct_sap        = int(($num_sap        / $num_all) * 100);

  ##print "gbtot_oraclent=$gbtot_oraclent\n";

  &sumtot("S",  "Informix-UX" , $num_informix   , $ver_informix_low,   $ver_informix_high,  $dbtot_informix, $gbtot_informix );
  &sumtot("S",  "OracleDB-UX" , $num_oracle     , $ver_oracle_low,     $ver_oracle_high,    $dbtot_oracle,   $gbtot_oracle   );
  &sumtot("S",  "OracleDB-NT" , $num_oraclent   , $ver_oraclent_low,   $ver_oraclent_high,  $dbtot_oraclent, $gbtot_oraclent );
  &sumtot("S",  "OracleApps " , $num_oracleapps , $ver_oracleapps_low, $ver_oracleapps_high );
  &sumtot("S",  "MSSQL      " , $num_mssql      , $ver_mssql_low,      $ver_mssql_high,     $dbtot_mssql,    $gbtot_mssql    );
  &sumtot("S",  "SAP        " , $num_sap        , $ver_sap_low,        $ver_sap_high );

  print HTMLSYS "</table><p><table border=1 bgcolor=lightgrey>\n";
  print HTMLSYS "<tr bgcolor=$table_headbgcolor><th><h5><i>DBMS/<br>Application<th><h5><i>Instance Count<th><h5><i>Percent of Total Instances<th><h5><i>Low Version<th><h5><i>High Version\n";
  print HTMLSYS "<tr><td><h5><font color=darkblue>Informix   </font><td align=right><h5>$num_informix   <td align=right><h5>$pct_informix %\n";
  print HTMLSYS "<td><h5>$ver_informix_low <td><h5>$ver_informix_high\n";
  print HTMLSYS "<tr><td><h5><font color=red>     OracleDB-UX</font><td align=right><h5>$num_oracle     <td align=right><h5>$pct_oracle %\n";
  print HTMLSYS "<td><h5>$ver_oracle_low <td><h5>$ver_oracle_high\n";
  print HTMLSYS "<tr><td><h5><font color=ff0090>  OracleDB-NT</font><td align=right><h5>$num_oraclent   <td align=right><h5>$pct_oraclent %\n";
  print HTMLSYS "<td><h5>$ver_oraclent_low <td><h5>$ver_oraclent_high\n";
  print HTMLSYS "<tr><td><h5><font color=darkred> OracleApps </font><td align=right><h5>$num_oracleapps <td align=right><h5>$pct_oracleapps %\n";
  print HTMLSYS "<td><h5>$ver_oracleapps_low <td><h5>$ver_oracleapps_high\n";
  print HTMLSYS "<tr><td><h5><font color=green>   MSSQL      </font><td align=right><h5>$num_mssql      <td align=right><h5>$pct_mssql %\n";
  print HTMLSYS "<td><h5>$ver_mssql_low <td><h5>$ver_mssql_high\n";
  print HTMLSYS "<tr><td><h5><font color=violet>  SAP        </font><td align=right><h5>$num_sap        <td align=right><h5>$pct_sap   %\n";
  print HTMLSYS "<td><h5>$ver_sap_low <td><h5>$ver_sap_high\n";
  print HTMLSYS "</table>\n";

  #---- Create instance detail

  print HTMLSYS "<hr><h4> Instance Detail - $high_host Instance(s) - $grand_total_size GB Total Size</h5>\n";
  print HTMLSYS "<table border=1 bgcolor=lightgrey>\n";
  print HTMLSYS "<tr bgcolor=$table_headbgcolor>\n";
  print HTMLSYS "<th colspan=5><h5><i>Status/<br>Instance\n";
  print HTMLSYS "<th><h5><i>DBMS/<br>Application\n";
  print HTMLSYS "<th><h5><i><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n";
  print HTMLSYS "<th><h5><i>Events\n";
  print HTMLSYS "<th><h5><i>Status<br>/CONFIG<br>Flags\n";
  ## print HTMLSYS "<th><h5><i>DBMS/<br>Package<br>Version\n";
  print HTMLSYS "<th><h5><i>Bkup Method:<br>Hours Since<br>Last Bkup/<br>Threshold<br>(R)erun Cmd\n";
  print HTMLSYS "<th><h5><i>CPU<br>Model-CPUs<br>(MB Mem)\n";
  print HTMLSYS "<th><h5><i>O/S<br>Level<br>(Mode)\n";
  print HTMLSYS "<th><h5><i>Alloc/<br>Used<br>GB\n";
  print HTMLSYS "<th><h5><i>Mon.<br>Dur.<br>Secs.<br>(% Of<br>Total)\n";
  print HTMLSYS "<th><h5><i>Misc.\n";
  print HTMLSYS "</tr>\n";

  $tot_db       = 0;
  $tot_appldb   = 0;
  $tot_dbspaces = 0;
  $tot_tables   = 0;
  $tot_alloc    = 0;
  $tot_used     = 0;
  $tot_disks    = 0;
  $tot_maxusers = 0;

  #---- Clean instances table for this mode

  &logit("  Cleaning out repository - dbamon.instances and dbamon.databases tables");
  $sqlstmt = "delete from dbamon.instances where dbamonmode = '$modeout'";
  runSQL($sqlstmt);
  $sqlstmt = "delete from dbamon.databases where dbamonmode = '$modeout'";
  runSQL($sqlstmt);

  $zcnt = 0;

  $i_rm = 1;
  while ($i_rm <= $high_host) 
  {
    printf RPT "%20s %20s %10s %8s %6s %12s %10s %4d %4d %6d %4d %4d %5d\n",
    $hostname[$i_rm],
    $title1[$i_rm],
    $title2[$i_rm],
    $hw_model[$i_rm],
    $os_version[$i_rm],
    $sw_version[$i_rm],
    $sn[$i_rm],
    $num_databases[$i_rm],
    $num_dbspaces[$i_rm],
    $num_tables[$i_rm],
    $system_size[$i_rm],
    $system_used[$i_rm],
    $maxusers[$i_rm]
    ; 

    printf RPTSN "%20s %15s %15s\n",$title[$i_rm],$sw_version[$i_rm],$sn[$i_rm];

    #---- Insert row into instances table

    if ($hostname[$i_rm] ne "" && $use_repository eq "Y")
    {
      $up[$i_rm] = "N" if $up[$i_rm] eq "";
 
      #---- 2011/04/13 5.07 BB - Just copy all of the IDn vars over to the MISCn vars
      $misc1[$i_rm] = $id1[$i_rm];
      $misc2[$i_rm] = $id2[$i_rm];
      $misc3[$i_rm] = $id3[$i_rm];
      $misc4[$i_rm] = $id4[$i_rm];
      $misc5[$i_rm] = $id5[$i_rm];
      $misc6[$i_rm] = $id6[$i_rm];
      $misc7[$i_rm] = $id7[$i_rm];
      $misc8[$i_rm] = $id8[$i_rm];
      $misc9[$i_rm] = $id9[$i_rm];
      $misc10[$i_rm] = $id10[$i_rm];

      if (length($hw_model[$i_rm]) > 16)
      {
	$hw_model[$i_rm] = substr($hw_model[$i_rm],0,16);
      }
      chomp($hw_model[$i_rm]);

      #---- TEMP FIX for MSSQL repos
      $z_alloc = int($system_size[$i_rm]); 
      $z_used  = int($system_used[$i_rm]); 

      $sqlstmt =  "insert into dbamon.instances 
        (instance_key,dbamonmode,status,instance,system,model,os,dbms,dbmsver,dbmssn,alloc,
         used,misc1,misc2,misc3,misc4,misc5,misc6,misc7,misc8,misc9,misc10,
         fqhostname,cpucount,instance_mem_mb)";
      $sqlstmt .= "values (
      '$instance_key[$i_rm]',
      '$modeout',
      '$up[$i_rm]',
      '$title1[$i_rm]',
      '$hostname[$i_rm]',
      '$hw_model[$i_rm]-$hw_processors[$i_rm]',
      '$os[$i_rm]-$os_version[$i_rm]',
      '$dbms[$i_rm]',
      '$sw_version[$i_rm]',
      '$sn[$i_rm]',
      '$z_alloc',
      '$z_used',
      '$misc1[$i_rm]',
      '$misc2[$i_rm]',
      '$misc3[$i_rm]',
      '$misc4[$i_rm]',
      '$misc5[$i_rm]',
      '$misc6[$i_rm]',
      '$misc7[$i_rm]',
      '$misc8[$i_rm]',
      '$misc9[$i_rm]',
      '$misc10[$i_rm]',
      '$fqhostname[$i_rm]',
      '$hw_processors[$i_rm]',
      '$total_shmem[$i_rm]'
      )";
      ##print "sqlstmt=$sqlstmt \n";
      runSQL($sqlstmt);

      #---- Insert into the DATABASES table
      foreach $thisdb (split('\n',$dblist[$i_rm]))
      {
	$sqlstmt =  "insert into dbamon.databases 
	  (dbamonmode,instance,system,fqhostname,dbms,databasename)
	values (
	'$modeout',
	'$title1[$i_rm]',
	'$hostname[$i_rm]',
	'$fqhostname[$i_rm]',
	'$dbms[$i_rm]',
	'$thisdb'
	)";
	##print "sqlstmt=$sqlstmt \n";
	runSQL($sqlstmt);
        $zcnt++;
      }
    }

    ##DEBUG## print "up="up[$i_rm]" mustbeup="t_mustbeup[$i_rm]

    #---- Clear work variables 
    my $zhost = "";
    my $zdomain = "";

    $black_flag = 0;

    if ($bgcolor_flag == 1)
    {
      $bgc = "ffffff";
      $bgcolor_flag = 0;
    }
    else
    {
      $bgc = "eeeeee";
      $bgcolor_flag = 1;
    }

    # Start - Debug a problem
    ##print "summarize() m_critical=$m_critical[$i_rm] title=$title[$i_rm]\n";
    # End   - Debug a problem

    if ($www_magnify eq "Y")
    {
      &sumprint($i_rm,"<form name=pulldown_${modeout}_$i_rm>");
    }

    print HTMLSYS "<tr bgcolor=$bgc>\n";

    $health_flag[$i_rm] = 0;

    ##print "m_critical[$i_rm]=$m_critical[$i_rm]\n";

    if ($m_critical[$i_rm] > 0) 
    {
      &sumprint($i_rm, "<td nowrap bgcolor=red>" );
    }
    elsif ($runmon[$i_rm] eq "N")  
    {
      &sumprint($i_rm, "<td nowrap bgcolor=white>" );
      $health_flag[$i_rm] = -1;
    }
    elsif ($up[$i_rm] ne "Y" && $t_mustbeup[$i_rm] eq "N")
    {
      &sumprint($i_rm, "<td nowrap bgcolor=black>" );
      $black_flag = 1;
      $health_flag[$i_rm] = -1;
    }
    elsif ($up[$i_rm] eq "I")
    {
      &sumprint($i_rm, "<td nowrap bgcolor=black>" );
      $black_flag = 1;
      $health_flag[$i_rm] = -1;
    }
    elsif ($up[$i_rm] eq "D")      
    {
      &sumprint($i_rm, "<td nowrap bgcolor=gray>" );
    }
    elsif ($m_warning[$i_rm] > 0)  
    {
      &sumprint($i_rm, "<td nowrap bgcolor=yellow>" );
    }
    elsif ($m_info[$i_rm] > 0)    
    {
      &sumprint($i_rm, "<td nowrap bgcolor=slateblue>" );
    }
    elsif ($m_user[$i_rm] > 0)    
    {
      &sumprint($i_rm, "<td nowrap bgcolor=#99cc00>" );
      $health_flag[$i_rm] = 100;
    }
    elsif ($m_perf[$i_rm] > 0)    
    {
      &sumprint($i_rm, "<td nowrap bgcolor=lightskyblue>" );
      $health_flag[$i_rm] = 100;
    }
    elsif ($m_sec[$i_rm] > 0)    
    {
      &sumprint($i_rm, "<td nowrap bgcolor=mediumpurple>" );
      $health_flag[$i_rm] = 100;
    }
    elsif ($m_note[$i_rm] > 0)    
    {
      &sumprint($i_rm, "<td nowrap bgcolor=lime>" );
      $health_flag[$i_rm] = 100;
    }
    else                           
    {
      &sumprint($i_rm, "<td nowrap bgcolor=lime>" );
      $health_flag[$i_rm] = 100;
    }

    if ($black_flag == 1) 
    {
      $fontstr = "<font color=silver>";
    }
    else    
    {
      $fontstr = "<font color=black>";
    }

    #---- Hostname

    if ($runmon[$i_rm] eq "B")  { $z = "(B)"; }
    else                        { $z = "";    }

    if ($standby[$i_rm] eq "STANDBY")  { $z .= "(Standby)"; }
    if ($dr_status[$i_rm] eq "(Sec)" ) { $z .= "(HDR-Sec) "; }
    if ($dr_status[$i_rm] eq "(Prim)") { $z .= "(HDR-Pri) "; }
    if ($cluster_name[$i_rm] ne "")  
    { 
      $z .= "($cluster_name[$i_rm]-$cluster_thisnodestatus[$i_rm])"; 
    }

    if ($ops[$i_rm] eq "YES")          { $z .= "(RAC-N$inst_num[$i_rm])" }

    if ($asmflag[$i_rm])               { $z .= "(ASM)" }
    if ($asm[$i_rm] eq "YES")          { $z .= "(ASM)" }

    if ($priority[$i_rm] eq "H") { $z .= " <img src='img/hipri.gif' height=11 border=0>"; }
    if ($priority[$i_rm] eq "L") { $z .= " <img src='img/lopri.gif' height=10 border=0>"; }

    ##$z3 = "";
    ##if ($priority[$i_rm] eq "H") { $z3 = " <h6>(Pri=Hi)"; }
    ##if ($priority[$i_rm] eq "L") { $z3 = " <h6>(Pri=Lo)"; }

    if ($host_url[$i_rm] eq "")
    {
      ##Old &sumprint($i_rm, "<h5>$fontstr $hostname[$i_rm]$z" );
      $_ = $title[$i_rm];
      s/ //g;
      $ztitle = $_;
      if ($arg eq "test") { $z2 = "details_test" }
      else                { $z2 = "details" }
      ##TEST26 sumprint($i_rm, "<h5><a HREF='$z2/$ztitle.html' title='Details'>$fontstr $hostname[$i_rm] $z</a>" );
      &sumprint($i_rm, "<h5>\&nbsp\; <a HREF='$z2/$ztitle.html' title='Details'>$fontstr $hostname[$i_rm].$title1[$i_rm] $z</a> \&nbsp\;");
    }
    else 
    {
      ##TEST26 &sumprint($i_rm,  "<a href='$host_url[$i_rm]'><h5>$fontstr $hostname[$i_rm]$z</a>" );
      &sumprint($i_rm,  "<a href='$host_url[$i_rm]'><h5>$fontstr $title1[$i_rm]$z</a>" );
    }
    #if ($pager_flag[$i_rm] == 1)       
    #{ 
    #  &sumprint($i_rm,  "<img src='img/pager.gif' height=12>" );
    #}

    #---- Title1

    &sumprint($i_rm,  "<td wrap $style_tiny>" );

    $stars_flag = 0;
    if ($title1url[$i_rm] eq "[CMDB]" || $title1url[$i_rm] eq "[CMDB]")
    {
      ##print "[CMDB] Promotion: fqhostname=$fqhostname[$i_rm] urlfqhost=$urlfqhost[$i_rm]\n";
      $stars_flag = 1;

      if ($fqhostname[$i_rm] ne $urlfqhost[$i_rm] && $urlfqhost[$i_rm] ne "" && length($urlfqhost[$i_rm]) > length($fqhostname[$i_rm]))
      {

        $fqhostname[$i_rm] = $urlfqhost[$i_rm];
        $fqoverride = 1;
      }
      else
      {
        $fqoverride = 0;
      }


      # Extract domain
      $ndx = index($fqhostname[$i_rm],'.');
      $zhost   = lc substr($fqhostname[$i_rm],0,$ndx);     
      $zdomain = lc substr($fqhostname[$i_rm],$ndx+1);     

      $zhost = $rmt_hostname[$i_rm] if $rmt_hostname[$i_rm] ne "" ;

      ##print "[CMDB] Promotion: fqhostname=$fqhostname[$i_rm] ndx=$ndx zhost=$zhost zdomain=$zdomain\n";
      ##print "test1 - zhost=$zhost title=$title[$i_rm]\n";

      if ($dbms[$i_rm] eq "MSSQL")
      {
        $title1url[$i_rm] = "http://starprod.cos.company.com/starws/ServerSummary.do?m_sBtnAction=Select&host=$zhost&dns=$zdomain";
      }
      else
      {
        $title1url[$i_rm] = "http://starprod.cos.company.com/staradm/SilverStream/Pages/pgSRRpt_DBSummary.html?host_nm=$zhost&instance=$title1[$i_rm]&dns_domain=$zdomain";
      }
      ##print "[CMDB] Promotion: fqhostname=$fqhostname[$i_rm] ndx=$ndx zhost=$zhost zdomain=$zdomain t1url=$title1url[$i_rm] fqoverride=$fqoverride\n";
    }

    if ($title2[$i_rm]) 
    {
      if ($title1url[$i_rm] eq "")
      { 
	&sumprint($i_rm, "$title1[$i_rm]<sub>T1</sub> " );
      }
      else 
      {
	&sumprint($i_rm, "<a HREF='$title1url[$i_rm]'>$title1[$i_rm]<sub>T1</sub></a>" );
      }
    }
    
    #---- Title2
    if ($title2[$i_rm]) 
    {
      ##&sumprint($i_rm, "<td nowrap>" );
      if ($title2url[$i_rm] eq "")
      {
	&sumprint($i_rm, "$title2[$i_rm]<sub>T2</sub> " );
      }
      else
      {
	&sumprint($i_rm, "<a HREF='title2url[$i_rm]'>$title2[$i_rm]<sub>T2</sub></a> " );
      }
      &sumprint($i_rm, "\n" );
    }

    #---- Title3
    &sumprint($i_rm, "$title3[$i_rm]<sub>T3</sub> \n" ) if $title3[$i_rm];

    #---- TAG URL         
    #----   See if there is TAG data
    &sumTagSelect("$titleraw[$i_rm]");
    if ($tag_text)
    {
      $ztitle = "Last Updated on $tag_ts by $tag_initials";
    }
    else
    {
      $ztitle = "No Tag Data";
    }
    &sumprint($i_rm," <a HREF='/cgi-bin/dbamon_tag.pl?$titleraw[$i_rm]' title='$ztitle'>[$tag_text]</a> ");

    # New place for ID1, ID2, ID3
    &sumprint($i_rm, "<td nowrap $style_tiny>\n" );
    &sumprint($i_rm, " $id1[$i_rm]<sub>I1</sub>\n" ) if $id1[$i_rm] ne "";
    &sumprint($i_rm, " $id2[$i_rm]<sub>I2</sub>\n" ) if $id2[$i_rm] ne "";
    &sumprint($i_rm, " $id3[$i_rm]<sub>I3</sub>\n" ) if $id3[$i_rm] ne "";
    &sumprint($i_rm, " $id4[$i_rm]<sub>I4</sub>\n" ) if $id4[$i_rm] ne "";
    &sumprint($i_rm, "<br>\n" ); 
    &sumprint($i_rm, " $id5[$i_rm]<sub>I5</sub>\n" ) if $id5[$i_rm] ne "";
    &sumprint($i_rm, " $id6[$i_rm]<sub>I6</sub>\n" ) if $id6[$i_rm] ne "";
    &sumprint($i_rm, " $id7[$i_rm]<sub>I7</sub>\n" ) if $id7[$i_rm] ne "";
    &sumprint($i_rm, "<br>\n" ); 
    &sumprint($i_rm, " $id8[$i_rm]<sub>I8</sub>\n" ) if $id8[$i_rm] ne "";
    &sumprint($i_rm, " $id9[$i_rm]<sub>I9</sub>\n" ) if $id9[$i_rm] ne "";
    &sumprint($i_rm, " $id10[$i_rm]<sub>I10</sub>\n" ) if $id10[$i_rm] ne "";

    if ($use_cmdb)
    {
      #         
      # See if there is CMDB data
      #
      $zfqhost = $fqhostname[$i_rm];
      &sumCMDBSelect("$fqhostname[$i_rm]");
      if ($star_class)
      {
	&sumprint($i_rm," <a href='http://starprod.thecompany.com/starws/ServerSummary.do?m_sBtnAction=Select&m_sServerId=$star_server_id' title='CMDB Server Link'><font color=green>$star_pri / $star_class /<br> $star_cr / $star_bus_use /<br> $star_supt_team</font></a>");
	$ztitle = "Last Updated on $tag_ts by $tag_initials";
	$id4[$i_rm] = $star_class;
	$id7[$i_rm] = $star_supt_team;
	$id8[$i_rm] = $star_pri;
      }
      else
      {
	if ($zfqhost eq "")
	{
	  &sumprint($i_rm," <font color=green>(CMDB Data not found -<br>Server not found in DNS)</font></a>");
	}
	else
	{
	  &sumprint($i_rm," <font color=green>(CMDB Data not found server:<br> ($zfqhost))</font></a>");
	}
      }
    }

    if (! $flag_uptime && ! $flag_readings) { &sumprint($i_rm, "<td>"); }
    #---- Uptime - A new <td>
    if ($flag_uptime)
    {
      &sumprint($i_rm, "\n" );
      $_ = $title[$i_rm];
      s/ //g;
      $z1 = $_;
      $z2 = &uptimeCalc($z1);
      &sumprint($i_rm, "<td align=right bgcolor=#a8a8a8>$z2" );
    }

    #---- Readings - A new <td>
    if ($flag_readings)
    {
      &sumprint($i_rm, "<td nowrap $style_tiny align=right> " );
      if ( defined $reading_cpubusy_pct[$i_rm] ) 
      {
        $zr_cpu  = $reading_cpubusy_pct[$i_rm]   ;
        $zr_mem  = $reading_memused_pct[$i_rm]   ;  
        $zr_disk = $reading_diskqueuelen_avg[$i_rm] ;

        if    ($zr_cpu  >= 95.00) 
        { 
          $zr_c_cpu = "pink"; 
          $zi_c_cpu = "red"
        }
        elsif ($zr_cpu  >= 90.00) 
        { 
          $zr_c_cpu = "gold"; 
          $zi_c_cpu = "yellow"
        }
        else                      
        { 
          $zr_c_cpu = "lime"; 
          $zi_c_cpu = "green"
        }

        if    ($zr_mem  >= 99.50) 
        { 
          $zr_c_mem = "pink"; 
          $zi_c_mem = "red"
        }
        elsif ($zr_mem  >= 98.00) 
        { 
          $zr_c_mem = "gold"; 
          $zi_c_mem = "yellow"
        }
        else                      
        { 
          $zr_c_mem = "lime"; 
          $zi_c_mem = "green"
        }

        if    ($zr_disk >= 2)     
        { 
          $zr_c_disk = "pink"; 
          $zi_c_disk = "red"
        }
        elsif ($zr_disk >= 1)     
        { 
          $zr_c_disk = "gold"; 
          $zi_c_disk = "yellow"
        }
        else                      
        { 
          $zr_c_disk = "lime"; 
          $zi_c_disk = "green"
        }

        $readings_do_table = 1; 
        if ($readings_do_table) 
        {
	  $readings_string = "<table border=0>
	    <tr bgcolor=$zr_c_cpu ><td nowrap align=right $style_tiny>
	      <a href='/cgi-bin/dbamon_magnify_run.pl?g02,$mode,$dbcfilename[$i_rm],.,$titleraw[$i_rm],$dbms[$i_rm],G'> <b> CPU Busy: ${zr_cpu}% </b> </a> 
	    <tr bgcolor=$zr_c_mem ><td nowrap align=right $style_tiny>
	      <a href='/cgi-bin/dbamon_magnify_run.pl?g06,$mode,$dbcfilename[$i_rm],.,$titleraw[$i_rm],$dbms[$i_rm],G'> <b> MEM Used: ${zr_mem}% </b> </a> 
	    <tr bgcolor=$zr_c_disk><td nowrap align=right $style_tiny>
	      <a href='/cgi-bin/dbamon_magnify_run.pl?g07,$mode,$dbcfilename[$i_rm],.,$titleraw[$i_rm],$dbms[$i_rm],G'> <b> PDisk Avg QLen: ${zr_disk} </b> </a>
	  </table>"; 
        }
        else
        {
	  #---- This is NOT COOL
	  $readings_string = "
	      <font color=$zr_c_cpu ><a href='/cgi-bin/dbamon_magnify_run.pl?g02,$mode,$dbcfilename[$i_rm],.,$titleraw[$i_rm],$dbms[$i_rm],G'> CPU Busy: ${zr_cpu}% </a> </font>
		<img src='/dbamon/img/$zi_c_cpu.gif' width=9>
	  <br><font color=$zr_c_mem ><a href='/cgi-bin/dbamon_magnify_run.pl?g06,$mode,$dbcfilename[$i_rm],.,$titleraw[$i_rm],$dbms[$i_rm],G'> MEM Used: ${zr_mem}% </a> </font>
		<img src='/dbamon/img/$zi_c_mem.gif' width=9>
	  <br><font color=$zr_c_disk ><a href='/cgi-bin/dbamon_magnify_run.pl?g07,$mode,$dbcfilename[$i_rm],.,$titleraw[$i_rm],$dbms[$i_rm],G'> PDisk Avg QLen: ${zr_disk} </a> </font>
		<img src='/dbamon/img/$zi_c_disk.gif' width=9>
	  "; 
        }
        #print "readings_string=$readings_string"; 
        &sumprint($i_rm, $readings_string );
      }
    }

    #---- DBMS - A new <td>

    #---- Massage os
    if    ($os[$i_rm] eq "UX")  {  $os_out = "HP-UX"; }
    elsif ($os[$i_rm] eq "NT") 
    {  
      if    ($os_version[$i_rm] =~ /^4/)   { $os_out = "NT4"; }
      elsif ($os_version[$i_rm] =~ /^5.2/) { $os_out = "W2K+3"; }
      elsif ($os_version[$i_rm] =~ /^5/)   { $os_out = "W2K"; }
      elsif ($os_version[$i_rm] =~ /^6.0/) { $os_out = "WinVista"; }
      elsif ($os_version[$i_rm] =~ /^6.1/) { $os_out = "Win7/2008"; }
      else                                 { $os_out = "Win?"; }
      $os_out .= $os64bit[$i_rm] if $os64bit[$i_rm];
    }
    else                        {  $os_out = $os[$i_rm]; }
    if (
        ($os_out =~ /ux/i  && $os_version[$i_rm]) || 
        ($os_out =~ /sol/i && $os_version[$i_rm])
       )
    {
      $os_out .= " " . $os_version[$i_rm];  
    } 

    #---- Massage comm_method
    if ($comm_method[$i_rm] eq "ssh") 
    {
      if ($openssh[$i_rm] == 1)
      { 
        $via = "ssh (OpenSSH)"; 
      }
      else
      { 
        $via = "ssh"; 
      }
    }
    else                              { $via = "remsh"; }

    if ($sw_version[$i_rm] =~ /^0/)
    {
      $zver = substr($sw_version[$i_rm],1);
    }
    else
    {
      $zver = $sw_version[$i_rm];
    }
    $zver .= $mssql64bit[$i_rm] if $mssql64bit[$i_rm];

    if ($dbmsout[$i_rm] =~ /MSSQL/) 
    {
      if ($mssql_patchlevel[$i_rm]) { $zver .= " $mssql_patchlevel[$i_rm]"; }

      if    ($sw_version[$i_rm] =~ /^08\.0/) { $zver .= " (2000)"; } 
      elsif ($sw_version[$i_rm] =~ /^09\.0/) { $zver .= " (2005)"; } 
      elsif ($sw_version[$i_rm] =~ /^10\.0/) { $zver .= " (2008)"; } 
      elsif ($sw_version[$i_rm] =~ /^10\.5/) { $zver .= " (2008R2)"; } 
      else                            { $zver .= " (SQL-?)"; } 

      if ($mssql_edition[$i_rm]) 
      { 
        $zedition = $mssql_edition[$i_rm];
        $zedition =~ s/StandardEdition/SE/;
        $zedition =~ s/EnterpriseEdition/EE/;
        $zedition =~ s/ExpressEdition/Express/;
        $zedition =~ s/EnterpriseEvaluationEdition/EEE/;
        $zver .= " $zedition"; 
      }
    }

    &sumprint($i_rm, "<td nowrap><h6>DBMS: <font color=$dbms_color[$i_rm]>$dbmsout[$i_rm] <br> &nbsp; $zver</font>" );

    #---- See if any patches are present
    if ($sw_patchcount[$i_rm] > 0)
    {
      &sumprint($i_rm," <a HREF='/cgi-bin/dbamon_patches.pl?$hostname[$i_rm],$orasid[$i_rm],$mode' title='Patch Report'><font color=$dbms_color[$i_rm]>[+${sw_patchcount[$i_rm]} P]</font></a>");
    }

    if ($dbcount[$i_rm] > 0)
    {
      &sumprint($i_rm, " <br>DBCount: <font color=$dbms_color[$i_rm]>$dbcount[$i_rm]</font>");
    }

    if ($system_size[$i_rm] > 0)
    {
      &sumprint($i_rm, " &nbsp; InstanceSize: <font color=$dbms_color[$i_rm]>$system_size[$i_rm]</font> (gB)");
    }

    #if ($rsh_service[$i_rm])
    #{
    #  &sumprint($i_rm, " <br>RemshSvc: <font color=$dbms_color[$i_rm]>$rsh_service[$i_rm]</font>");
    #}

    if ($server_type[$i_rm])
    {
      &sumprint($i_rm, " <br>ServerType: <font color=$dbms_color[$i_rm]>$server_type[$i_rm]</font>");
    }

    if ($hw_processors[$i_rm])
    {
      &sumprint($i_rm, " &nbsp; CPUCount: <font color=$dbms_color[$i_rm]>$hw_processors[$i_rm]</font>");
    }

    &sumprint($i_rm, " <br>On: <font color=$dbms_color[$i_rm]>$os_out</font>");
    &sumprint($i_rm, " Via: <font color=$dbms_color[$i_rm]>$via</font>");

    $z = ""; 

    #if ($system_size[$i_rm] ne "")
    #{
    #  $z1 = int($system_size[$i_rm]);
    #  $z .= " Disk: <font color=$dbms_color[$i_rm]>${z1}GB</font>";
    #}

    if ($shmsize[$i_rm] ne "")
    {
      if ($shmsize[$i_rm] < 1024)
      {
        $z1 = int($shmsize[$i_rm]);
        $z .= " <br>ShMem: <font color=$dbms_color[$i_rm]>${z1}MB</font>";
      }
      else
      {
        $z1 = sprintf ("%.1f", ($shmsize[$i_rm] / 1024));
        $z .= " <br>ShMem: <font color=$dbms_color[$i_rm]>${z1}GB</font>";
      }
    }
    if ($redo_30day_avg_gb[$i_rm] ne "")
    {
      $z1 = int($redo_30day_avg_gb[$i_rm]);
      $z .= " RedoRate: <font color=$dbms_color[$i_rm]>${z1}GB/Day</font>";
    }
    &sumprint($i_rm, $z);

    #
    # Buttons
    #

    &sumprint($i_rm, "<td nowrap><h5>" );

    if ($www_check eq "Y")
    {
      # Ensure that we have the right instance
      $str = "${hostname[$i_rm]}${dbms[$i_rm]}${title1[$i_rm]}${orasid[$i_rm]}";
      chop($ck = `echo "$str" | cksum | awk '{ print \$1 }'`);
      ##print "str=$str ck=$ck\n";

      #&sumprint($i_rm, "<a HREF='/cgi-bin/dbamon_check.pl?$modeout,$i_rm,$ck' title='Check Status'><img src='img/idea.gif' width=9 border=0></a>-" );
      &sumprint($i_rm, "<a HREF='/cgi-bin/dbamon_check.pl?$mode,$dbcfilenameshort[$i_rm]' title='Check Status'><img src='img/idea.gif' width=12 border=0></a>" );
      &sumprint($i_rm, " ");

    }

    # New 03Feb03
    if ($stars_flag == 1)
    {
      if ($rmt_hostname[$i_rm] ne "")
      {
        $zhost = $rmt_hostname[$i_rm];
      }
      else
      {
        if ($fqhostname[$i_rm] ne "")
        {
	  $ndx = index($fqhostname[$i_rm],'.');
	  $zhost   = lc substr($fqhostname[$i_rm],0,$ndx);     
        }
        else
        {
          $zhost = $hostfix[$i_rm];
        }
      }
      &debug($i_rm, "zhost=$zhost hostfix=$hostfix[$i_rm] rmt_hostname=$rmt_hostname[$i_rm]");
      
      &sumprint($i_rm, "<a HREF='/cgi-bin/dbamon_email.pl?$zhost,$zdomain,$title1[$i_rm]' title='EMail CMDB Contact(s)'><img src='img/mail.gif' border=0></a>" );
      &sumprint($i_rm, " " );
    }
    else
    {
      &sumprint($i_rm, "<img src='img/mail.gif' title='Not Using CMDB'>" );
      &sumprint($i_rm, " ");
    }

    # Report menu
    $_ = $title[$i_rm];
    s/ //g;
    $z = $_;
    #&sumprint($i_rm, "<a HREF='reports/${z}.html'>R</a>-" );

    #---- 2011/01/21 BB - Off for now... until i decide what to do with this
    ##&sumprint($i_rm, "<a HREF='reports/${z}.html' title='Reports Menu'><img src='img/dbamon_graphs.gif' width=12 border=0></a>-" );

    # Decide which notepad icon to use
    $z_n_count = &noteCount($hostname[$i_rm],$server[$i_rm]);

    ##print "z_n_count=$z_n_count\n";
    if ($z_n_count > 0) { $np_icon = "notepad";   }
    else                { $np_icon = "notepad_e"; }

    #---- Notepad
    &sumprint($i_rm,"<a HREF='/cgi-bin/dbamon_text.pl?$hostname[$i_rm]?$server[$i_rm]' title='Notepad'><img src='img/$np_icon.gif' width=10 border=0></a>" );
    &sumprint($i_rm," " );

    if ($flag_test_mode)
    {
      #---- Run testmode
      &sumprint($i_rm,"<a HREF='/cgi-bin/dbamon_runtest.pl?$dbcfilename[$i_rm]' title='Test Mode Run'><img src='img/rarrow.gif' width=15 border=0></a>" );
      &sumprint($i_rm," " );
    }

    if ($flag_user_list)
    {
      #---- User list 
      &sumprint($i_rm, "<a HREF='/cgi-bin/dbamon_report.pl?$mode,$dbcfilenameshort[$i_rm],.,us' title='User List'><img src='img/person.gif' border=0></a>" );
      &sumprint($i_rm," " );
    }

    if ($flag_helper)
    {
      #---- Helper
      &sumprint($i_rm, "<a HREF='/cgi-bin/dbamon_helper.pl?$mode,$titleraw[$i_rm],$zhost,$zdomain,$title1[$i_rm]' title='Helper'><img src='img/star.gif' border=0></a>" );
      ##&sumprint($i_rm,"-" );
    }

    #---- Edit DBC
    ##&sumprint($i_rm,"<a HREF='/cgi-bin/dbamon_dbcedit.pl?$dbcfilename[$i_rm]' title='View/Edit DBC Settings'>E</a>" );
    &sumprint($i_rm,"<a HREF='/cgi-bin/dbamon_dbcedit.pl?$dbcfilename[$i_rm]' title='View/Edit DBC Settings'><img src='img/hammer.png' width=16 border=0></a>" );
    &sumprint($i_rm," " );

    if ($instance_details_flag[$i_rm])
    {
      #---- Dump INSTANCE_DETAILS table 
      &sumprint($i_rm,"<a HREF='/cgi-bin/dbamon_tabledump.pl??ID?$instance_key[$i_rm]' title='INSTANCE_DETAILS Raw Data'>R</a>");
      &sumprint($i_rm," " );
    }


    #---- T is OFF for now
    #if ($userid[$i_rm] eq "") 
    #{
    #&sumprint($i_rm, "<a HREF='rlogin://$dbamon_userid\@$hostname[$i_rm]' title='rlogin'>T</a>" );
    #}
    #else          
    #{
    #&sumprint($i_rm, "<a HREF='rlogin://$userid[$i_rm]\@$hostname[$i_rm]' title='rlogin'>T</a>" );
    #}
    #&sumprint($i_rm, "-" );

    if ($html_details_flag[$i_rm] == 0)
    {
      &sumprint($i_rm,"D");
    }
    else
    {  
      $_ = $title[$i_rm];
      s/ //g;
      $z = $_;
      if ($arg eq "test") { $z2 = "details_test" }
      else                { $z2 = "details" }
      ##sumprint($i_rm, "<a HREF='$z2/$z.html' title='View Details'>D</a>" );
      sumprint($i_rm, "<a HREF='$z2/$z.html' title='View Details'><img src='img/drill.png' width=16 border=0></a>" );
    }
    &sumprint($i_rm," " );

    #---- Metrics viewer
    &sumprint($i_rm,"<a HREF='/cgi-bin/dbamon_metrics.pl?$mode,MENU,$titleraw[$i_rm]' title='Metrics Data Viewer'><img src='img/gauge.png' width=16 border=0></a>" );

    #---- This isn't needed because we have DBC edit/view above
    #&sumprint($i_rm, "<a HREF='/cgi-bin/dbamon_dbc.pl?$i_rm-$modeout' title='View DBC'>C</a>" );
    #&sumprint($i_rm, "-" );

    #---- 2nd Line
    ##&sumprint($i_rm,"<br>" );

    &sumprint($i_rm, " " );

    &sumprint($i_rm, "<a HREF='/cgi-bin/dbamon_metrics.pl?$mode,MCURRENT,$titleraw[$i_rm]' title='Current Metric Readings'>Cur</a>" );
    &sumprint($i_rm, " " );

    &sumprint($i_rm, "<a HREF='/cgi-bin/dbamon_inhibit.pl?$inhibfile[$i_rm]?$fqhostname[$i_rm]?$titleraw[$i_rm]' title='Inhibit'>Inh</a>" );
    &sumprint($i_rm, " " );

    #if ($what[$i_rm] eq "DB") { &sumprint($i_rm,"<a HREF='/cgi-bin/dbamon_ba_inhibit.pl?$titleraw[$i_rm]' title='Backup Age Inhibit'>Bi</a>" ) }
    #else                      { &sumprint($i_rm,"Bi" );}
    #&sumprint($i_rm, " " );

    #---- Event history
    if ($mode eq "test") 
    { 
      &sumprint($i_rm,"<a HREF='/cgi-bin/dbamon_hist.pl?$titleraw[$i_rm],test' title='Event History'>EvH</a>" ); 
    }
    else                 
    { 
      &sumprint($i_rm,"<a HREF='/cgi-bin/dbamon_hist.pl?$titleraw[$i_rm]' title='Event History'>EvH</a>" ) 
    }

    #---- Metrics viewer (Text URL)
    #&sumprint($i_rm," <a HREF='/cgi-bin/dbamon_metrics.pl?$mode,MENU,$titleraw[$i_rm]' title='Metrics Data Viewer'>Me</a>" );

    if ($save_file[$i_rm])
    {
      #---- Config save viewer
      &sumprint($i_rm," <a HREF='/cgi-bin/dbamon_config_save_view.pl?$save_file[$i_rm]' title='View Config Save Data'>Con</a>" );
    }

    # E Button (if applicable)
    $_ = $title[$i_rm];
    s/ //g;
    $z3 = $_;
    if ($arg eq "test") { $z2 = "events_current_test" }
    else                { $z2 = "events_current" }
    $events_url[$i_rm] = "$z2/${z3}.html";

    ##if ($html_events_flag[$i_rm] == 0)
    ##{
    ##  &sumprint($i_rm,   "E" );
    ##}
    ##else
    ##{  
    ##  &sumprint($i_rm,"<a HREF='$z2/${z3}.html' title='Events'>E</a>" );
    ##}

    if ($www_magnify eq "Y")
    {
      #---- 2nd Line
      &sumprint($i_rm,"<br>" );

      # Run this regardless of the DBMS - we need to build the options
      &summarizePulldown;   

      if ($dbms[$i_rm] =~ /Oracle/ || $dbms[$i_rm] =~ /MSSQL/)
      {
	# Ensure that we have the right instance
	$str = "${hostname[$i_rm]}${dbms[$i_rm]}${title1[$i_rm]}${orasid[$i_rm]}";
	chop($ck = `echo "$str" | cksum | awk '{ print \$1 }'`);
         
	&sumprint($i_rm, "<img src='img/dbamon_magnif.gif' width=12>" );

	$select_start = "<select STYLE='background: cyan;font-size: 7pt'
	   name=menuchoice onChange='location.href=document.pulldown_${modeout}_$i_rm.menuchoice.options[document.pulldown_${modeout}_$i_rm.menuchoice.selectedIndex].value'>\n";
	&sumprint($i_rm,$select_start);

        # pd_options was populated by summarizePulldown
	&sumprint($i_rm,$pd_options);

	$select_end = "</select>";
	&sumprint($i_rm,$select_end);
      }
    }

    if ($oemport[$i_rm] && $oemport[$i_rm] ne "?")
    {
      &sumprint($i_rm, "-");
      &sumprint($i_rm,"<a HREF='http://$fqhostname[$i_rm]:$oemport[$i_rm]/em' title='OEM WWW'><font size=1>OEM</font></a>" );
    }
    if ($isqlport[$i_rm] && $isqlport[$i_rm] ne "?")
    {
      &sumprint($i_rm, "-");
      &sumprint($i_rm,"<a HREF='http://$fqhostname[$i_rm]:$isqlport[$i_rm]/isqlplus' title='iSQLPlus WWW'><font size=1>iSQLPlus</font></a>" );
    }

    #---- Event messages

    if ($msgs[$i_rm] eq "")
    {
      ###&sumprint($i_rm,"<td nowrap bgcolor=#a8a8a8><h6>");
      &sumprint($i_rm,"<td nowrap bgcolor='$color_event_background'><h6>");
    }
    else
    {
      my   $zmsgs = $msgs[$i_rm]; 
      chop $zmsgs if ($zmsgs =~ /|$/);
      chop $zmsgs if ($zmsgs =~ /\s$/);
      $zmsgs =~ s/&nbsp$//i;
      &sumprint($i_rm,"<td bgcolor='$color_event_background'><h6><a HREF='$z2/${z3}.html' title='Events'> $zmsgs</a>");
    }
   
    #---- Flags

    $flagout="Pri=$priority[$i_rm] ";

    if ($runmon[$i_rm] eq "N")         { $flagout .= "Mon=N " }
    if ($runmon[$i_rm] eq "B")         { $flagout .= "Mon=B " }

    #if ($id1[$i_rm] ne "")             { $flagout .= "ID1=$id1[$i_rm] " }
    #if ($id2[$i_rm] ne "")             { $flagout .= "ID2=$id2[$i_rm] " }
    #if ($id3[$i_rm] ne "")             { $flagout .= "ID3=$id3[$i_rm] " }
    #if ($id4[$i_rm] ne "")             { $flagout .= "ID4=$id4[$i_rm] " }
    #if ($id5[$i_rm] ne "")             { $flagout .= "ID5=$id5[$i_rm] " }
    #if ($id6[$i_rm] ne "")             { $flagout .= "ID6=$id6[$i_rm] " }
    #if ($id7[$i_rm] ne "")             { $flagout .= "ID7=$id7[$i_rm] " }
    #if ($id8[$i_rm] ne "")             { $flagout .= "ID8=$id8[$i_rm] " }
    #if ($id9[$i_rm] ne "")             { $flagout .= "ID9=$id9[$i_rm] " }
    #if ($id10[$i_rm] ne "")             { $flagout .= "ID10=$id10[$i_rm] " }

    if ($make_tickets_dbc[$i_rm] eq "N") { $flagout .= "<font color=red>NoTix</font> " }
    if ($events_dbc[$i_rm]       eq "N") { $flagout .= "<font color=red>Events=N</font> " }

    if ($pager_flag[$i_rm] == 1)       { $flagout .= "PGR " }
    if ($t_mustbeup[$i_rm] eq "N")     { $flagout .= "MBUN " }
    if ($kio[$i_rm] == 1)              { $flagout .= "Kaio " }
    if ($ops[$i_rm] eq "YES")          { $flagout .= "RAC-N$inst_num[$i_rm] " }
    if ($standby[$i_rm] eq "STANDBY")  { $flagout .= "Standby " }
    if ($asyncio[$i_rm] eq "Y")        { $flagout .= "AsyncIO " }
    if ($wstats[$i_rm] eq "1")         { $flagout .= "WStats " }
    if ($segshared[$i_rm] == 1)        { $flagout .= "ShSegs " }
    if ($shmmagic[$i_rm] == 1)         { $flagout .= "Magic " }
    if ($dr_status[$i_rm] eq "(Sec)" ) { $flagout .= "HDR-S "  }
    if ($dr_status[$i_rm] eq "(Prim)") { $flagout .= "HDR-P " }
    if ($ts_command[$i_rm] ne "")      { $flagout .= "TSCmd "  }
    if ($t_arclog_cmd[$i_rm] ne "")    { $flagout .= "ArcCmd "  }
    if ($backup_command[$i_rm] ne "")  { $flagout .= "BkCmd "  }
    if ($is_threshold[$i_rm] ne "")    { $flagout .= "InSync "  }
    if ($comm_method[$i_rm] ne "")     { $flagout .= "$comm_method[$i_rm] "  }

    &sumprint($i_rm,"<td nowrap><h6><font color=purple>$flagout</font>");

    #---- DBMS version
    # 3.48 - moved this to dbms
    # &sumprint($i_rm,  "<td nowrap><h6>$sw_version[$i_rm]");

    #---- Hours since last backup

    if ($dbms[$i_rm] eq "MSSQL")
    {
      $bckhours[$i_rm]   = $bckhours_value_db[$i_rm];
      $bckhours_c[$i_rm] = $bckhours_color_db[$i_rm];
    }

    if (($runmon[$i_rm] eq "N" || $up[$i_rm] ne "Y" || $backup_age[$i_rm] eq "" || $backup_age[$i_rm] eq "N") && $backup_age_arc[$i_rm] eq "")
    {
      &sumprint($i_rm,  "<td nowrap><h6>$backup_method_long[$i_rm]");
      if ($arclog[$i_rm] ne "") { &sumprint($i_rm,  "($arclog[$i_rm])") }
      if ($bckhours[$i_rm] ne "" && $up[$i_rm] ne "I" && $db_status[$i_rm] ne "R" && $bckhours[$i_rm] ne "99999996")
      {
	&sumprint($i_rm,  "$bckhours[$i_rm]/" )
      }
    }
    else
    {
      &sumprint($i_rm,  "<td nowrap bgcolor=$bckhours_c[$i_rm]><h6>");

      if ($bckhours[$i_rm] ne "" || $backup_age[$i_rm] ne "")
      {
	if ($bckhours_c[$i_rm] eq "black")
	{
	  &sumprint($i_rm,  "<font color=white>" );
	}

	&sumprint($i_rm,  $backup_method_long[$i_rm] );
	if ($arclog[$i_rm] ne "") { &sumprint($i_rm,  "($arclog[$i_rm])" ) }

	if ($backup_method_long[$i_rm] ne "") { &sumprint($i_rm, ":" ) }

	&sumprint($i_rm, $bckhours[$i_rm]);

	if ($backup_age[$i_rm] ne "" && $up[$i_rm] ne "I" && $db_status[$i_rm] ne "R")
	{
	  &sumprint($i_rm,  "/$backup_age[$i_rm]" )
	}

	if ($backup_command[$i_rm] ne "" && $up[$i_rm] ne "I" && $db_status[$i_rm] ne "R")
	{
	  &sumprint($i_rm,  "(R)" )
	}

	if ($bckhours_c[$i_rm] eq "black")
	{
	  &sumprint($i_rm,  "</font>" )
	}
        &sumprint($i_rm,   " " );

	if ($backup_age_arc[$i_rm] ne "")
        {
          if ($bckhours_c[$i_rm] eq "" && $bckhours_c_arc[$i_rm] eq "black") { $bckhours_c_arc[$i_rm] = "green"; }
	  &sumprint($i_rm,  "<font color=$bckhours_c_arc[$i_rm]>" );
          &sumprint($i_rm,  "ARC:" );
	  &sumprint($i_rm,  "$mr_age_arc[$i_rm]/$backup_age_arc[$i_rm]" );
	  &sumprint($i_rm,  "</font>" );
        }

      }
    }

    #---- CPU model 

    &sumprint($i_rm,  "<td nowrap><h6>" );
    if (length($hw_model[$i_rm]) > 16) 
    { 
      $hw_model[$i_rm] = substr($hw_model[$i_rm],0,16) 
    }
    if (length($hw_model[$i_rm]) > 0)
    {
      if (length($hw_memory[$i_rm]) > 0)
      {
        &sumprint($i_rm, "$hw_model[$i_rm]-$hw_processors[$i_rm]($hw_memory[$i_rm])" );
      }
      else
      {
        &sumprint($i_rm, "$hw_model[$i_rm]-$hw_processors[$i_rm]" );
      }
    }
    &sumprint($i_rm, " ");

    #---- OS version

    &sumprint($i_rm,  "<td nowrap><h6>" );
    $z = "$os[$i_rm]-$os_version[$i_rm]";
 
    if ($os_mode[$i_rm] ne "")
    {
      $z .= "($os_mode[$i_rm])";
    }
    if ($os_out ne "")
    {
      $z .= "<br>$os_out";
    }
    &sumprint($i_rm,$z);

    # Totals
    $tot_db += $num_databases[$i_rm];
    $tot_appldb += $num_appldatabases[$i_rm];
    $tot_dbspaces += $num_dbspaces[$i_rm];
    $tot_tables += $num_tables[$i_rm];
    $tot_maxusers += $maxusers[$i_rm];

    #---- Space alloc/used

    ###if (int(system_size[$i_rm]) > 0)
    if ($system_size[$i_rm] ne "")
    {
      $z = int($system_size[$i_rm]) . "/" . int($system_used[$i_rm]);
      &sumprint($i_rm, "<td align=right nowrap><h6>$z" );
    }
    else
    {
      &sumprint($i_rm, "<td align=right><h6>");
    }
    $tot_alloc += int($system_size[$i_rm]);
    $tot_used += int($system_used[$i_rm]);

    #---- Duration on this instance

    if ($time_total == 0) { $time_total = 1; }
    $pct = int(($instance_duration[$i_rm] / $time_total) * 100);

    if  ($instance_duration[$i_rm] > 600) 
    { 
      &sumprint($i_rm,"<td align=right nowrap bgcolor=red><h6>");
      system("echo $date | dbamon_mailer -s 'DBAmon instance_duration=$instance_duration[$i_rm] $titleraw[$i_rm]' $admin_email") if -e "/tmp/dbamon_maildiag_flag.txt";
    }
    elsif  ($instance_duration[$i_rm] > 180) 
    { 
      &sumprint($i_rm,"<td align=right nowrap bgcolor=yellow><h6>" );
    }
    else                                  
    {
      &sumprint($i_rm,"<td align=right nowrap><h6>" );
    }

    &sumprint($i_rm, "$instance_duration[$i_rm](${pct}%)" );
    &sumprint($i_rm, " " );
    $instance_duration[$i_rm]  = "";

    #---- Misc (was SAP Release)

    &sumprint($i_rm,  "<td nowrap><h6>" );

    if ($sapkern[$i_rm] ne "")
    {
      &sumprint($i_rm,  "SAP:$sapkern[$i_rm]/$saprlse[$i_rm]" );
    }

    if ($num_disks[$i_rm] ne "")
    {
      &sumprint($i_rm, "Disks: $num_disks[$i_rm] ");
      $tot_disks += $num_disks[$i_rm];
    }

    #
    # Totals
    #

    $t_critical[$i_rm] += $m_critical[$i_rm];
    $t_warning[$i_rm]  += $m_warning[$i_rm];
    $t_info[$i_rm]     += $m_info[$i_rm];

    $m_critical[$i_rm] = 0;
    $m_warning[$i_rm]  = 0;
    $m_info[$i_rm]  = 0;
    $m_user[$i_rm]  = 0;
    $m_perf[$i_rm]  = 0;
    $m_sec[$i_rm]  = 0;
    $m_note[$i_rm]  = 0;

    if ($www_magnify eq "Y")
    {
      ##&sumprint($i_rm,"</tr></form>");
      &sumprint($i_rm,"</form>");
    }

    &debug($i_rm, "Before sumprint W zhost=$zhost title=$title[$i_rm]");

    # End of line for this instance
    &sumprint($i_rm,"","W",$system_size[$i_rm]);

    # See if there are any aliases
    if ($alias_list[$i_rm] ne "")
    {
      @words= split(/,/,$alias_list[$i_rm]);
      foreach $alias (@words)
      {
        $alias_short = (split(/\./,$alias)) [0];
        ##print "alias=$alias fqh=$fqhostname[$i_rm]\n";
        $alias_letter = uc substr($fqhostname[$i_rm],0,1);
        $alias_url = "<a href=\"/dbamon/alpha_${mode}/$alias_letter.html\">$fqhostname[$i_rm]</a>";

        #$alias_html = "<td nowrap bgcolor=white><h5>$alias_short(A)<td colspan=14><h6>(Alias for Server $alias_url)";
        #$alias_html = "<td nowrap bgcolor=white><h5>$alias(A)<td colspan=14><h6>(Alias for Server $alias_url)";
         $alias_html = "<td nowrap bgcolor=white><h5>$alias(A)<td colspan=4><td colspan=10><h6>ALIAS: For Server $alias_url";

        &sumprint($i_rm,"","A");
      }
    }

    #---- Increment counter
    $i_rm++;
  }

  &logit("Inserted $zcnt dbamon.databases rows");

  # Transaction integrity - Issue COMMIT (and turn on autocommit)
  #$dbh->commit();
  #$dbh->{AutoCommit} = 1;

  #---- Report trailer

  print RPT "\n    Total Maxusers: $tot_maxusers\n";

  #---- Create detail total line

  print HTMLSYS "</table>\n<hr>\n";
  print HTMLSYS "<form>\n";

  #---- Checks summary
  
  $z = $s_count + 2;
  print HTMLSYS "<h4>Montoring Details</h4>\n";
  print HTMLSYS "<table border=1 bgcolor=lightgrey>\n";
  print HTMLSYS "<tr> <td rowspan=$z> <b>Checks:</b>\n";
  print HTMLSYS "<tr> <th><h5>Description <th><h5>This<br>Iteration? <th><h5>Duration<br>(Minutes)\n";

  for ($i=1; $i<= $s_count; $i++)
  {
    print HTMLSYS "$s_array[$i] \n";
  }

  print HTMLSYS "</table><hr>\n";
  print HTMLSYS "<b>Note:</b> This page makes use of HTML tables and only looks\n";
  print HTMLSYS "correct when using Netscape 1.1+ (or any Web browser that supports HTML-V3)\n";
  print HTMLSYS "<hr>\n";

  close(HTMLSYS);
  close(RPT);
  close(RPTSN);
}
#--------------------------------------------------------------------------------
1;
